// This file was generated by Dashcode from Apple Inc.
// You may edit this file to customize your Dashboard widget.

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    setupParts();
	loadPreference();
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, createInstancePreferenceKey("your-key"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage

    var textFieldValue = document.getElementById("jikantext");	// replace with ID of text field
	setGlobalPreferenceForKey(textFieldValue.value, kJikanKey);

	textFieldValue = document.getElementById("gyoukantext");	// replace with ID of text field
	setGlobalPreferenceForKey(textFieldValue.value, kGyoukanKey);

	textFieldValue = document.getElementById("mojisutext");	// replace with ID of text field
	setGlobalPreferenceForKey(textFieldValue.value, kMojisuKey);

	textFieldValue = document.getElementById("gyousutext");	// replace with ID of text field
	setGlobalPreferenceForKey(textFieldValue.value, kGyousuKey);
	
	textFieldValue = document.getElementById("sizetext");	// replace with ID of text field
	setGlobalPreferenceForKey(textFieldValue.value, kMojiSizeKey);
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}

var kConvertLIndexKey = "convertLIndex";
var kConvertLTextKey = "convertLText";
var kConvertRIndexKey = "convertRIndex";
var kConvertRTextKey = "convertRText";

var kMojiSizeKey = "MojiSize";
var kJikanKey = "Jikan";
var kGyoukanKey = "Gyoukan";
var kMojisuKey = "Mojisu";
var kGyousuKey = "Gyousu";


function loadPreference()
{
	var convertLIndex = preferenceForKey(kConvertLIndexKey);
	if (convertLIndex) {
		var popupLIndex = document.getElementById("popupL");	// replace with ID of popup
		popupLIndex.object.setSelectedIndex(convertLIndex);
	}
	
	var convertRIndex = preferenceForKey(kConvertRIndexKey);
	if (convertRIndex) {
		var popupRIndex = document.getElementById("popupR");	// replace with ID of popup
		popupRIndex.object.setSelectedIndex(convertRIndex);
	}

	var textFieldValue;
	
	var mojiSize = preferenceForKey(kMojiSizeKey);
	if (mojiSize) {
		textFieldValue = document.getElementById("sizetext");	// replace with ID of text field
		textFieldValue.value = mojiSize;
	}
	
	var jikan = preferenceForKey(kJikanKey);
	if (jikan) {
		textFieldValue = document.getElementById("jikantext");	// replace with ID of text field
		textFieldValue.value = jikan;
	}
	
	var gyoukan = preferenceForKey(kGyoukanKey);
	if (gyoukan) {
		textFieldValue = document.getElementById("gyoukantext");	// replace with ID of text field
		textFieldValue.value = gyoukan;
	}
	
	var mojisu = preferenceForKey(kMojisuKey);
	if (mojisu) {
		textFieldValue = document.getElementById("mojisutext");	// replace with ID of text field
		textFieldValue.value = mojisu;
	}
	
	var gyousu = preferenceForKey(kGyousuKey);
	if (gyousu) {
		textFieldValue = document.getElementById("gyousutext");	// replace with ID of text field
		textFieldValue.value = gyousu;
	}

	CalcJiokuri();
	CalcGyookuri();
	CalcPageJiokuri();
	CalcPageGyouokuri();
}

function preferenceForKey(key) {
	var result;
	if (window.widget) {
		result = widget.preferenceForKey(createKey(key));
		if (!result) {
			result = widget.preferenceForKey(key);
		}
	}
/*	if (!result) {
		result = eval("kDefault" + key.substring(0,1).toUpperCase() + key.substring(1));
	}
*/	return result;
}

function createKey(key) {
	if (window.widget) {
        key = widget.identifier + "-" + key;
	}
	return key;
}

function savePref() {
	setInstancePreferenceForKey(mydiv.innerHTML, kDataKey);
}

function setInstancePreferenceForKey(value, key) {
	setGlobalPreferenceForKey(value, createKey(key));
}

function setGlobalPreferenceForKey(value, key) {
	if (window.widget) {
		widget.setPreferenceForKey(value, key);
	}
}


function onKeyupConvertL(event)
{
	CalcDTPConvert(false);
}

function onchangeUnitPopup(event)
{
	CalcDTPConvert(false);

    var popupLIndex = document.getElementById("popupL");	// replace with ID of popup
    popupLIndex = popupLIndex.object.getSelectedIndex();

    // Values you provide
    var popupRIndex = document.getElementById("popupR");	// replace with ID of popup
    popupRIndex = popupRIndex.object.getSelectedIndex();
    
	setGlobalPreferenceForKey(popupLIndex, kConvertLIndexKey);
	setGlobalPreferenceForKey(popupRIndex, kConvertRIndexKey);
}


function onKeyupConvertR(event)
{
	CalcDTPConvert(true);
}


function roundNum(num, keta)
{
	var chKeta = Math.pow(10, keta);
	var tmp_num = num * chKeta;
	var tmp_result = Math.round(tmp_num);
	var result = tmp_result/chKeta;
	
	return result;
}


function CalcDTPConvert(reverse)
{
/*
	var ConvertUnits = [
Q		[Q  -> Q,		Q  -> Pt,		Q  -> mm,		Q  -> inch],
Pt		[Pt -> Q,		Pt -> Pt,		Pt -> mm,		Pt -> inch],
mm		[mm -> Q,		mm -> pt,		mm -> mm,		mm -> inch],
inch	[inch -> Q,		inch -> pt,		inch -> mm,		inch -> inch]
	];

	var ConvertUnits = [
		[1,			0.709,		0.25,		0.01],
		[1.4112,	1,			0.3528,		0.0139],
		[4,			2.835,		1,			0.03937],
		[101.6,		72,			25.4,		1]
	];
*/
	var ConvertUnits = [
		[1,			0,			0.25,		0],
		[1.4112,	1,			0.3528,		0],
		[4,			2.835,		1,			0],
		[101.6,		72,			25.4,		1]
	];

	// Values you provide
    var popupLIndex = document.getElementById("popupL");	// replace with ID of popup
    popupLIndex = popupLIndex.object.getSelectedIndex();

    // Values you provide
    var popupRIndex = document.getElementById("popupR");	// replace with ID of popup
    popupRIndex = popupRIndex.object.getSelectedIndex();
    
	var answerTextFieldID;
	var calcValue;
	
	if (reverse) {
		calcValue = document.getElementById("textfieldR");	// replace with ID of text field
		calcValue = calcValue.value;
	
		var tmpVar = popupLIndex;
		popupLIndex = popupRIndex;
		popupRIndex = tmpVar;
		answerTextFieldID = "textfieldL";
		
	} else {
		calcValue = document.getElementById("textfieldL");	// replace with ID of text field
		calcValue = calcValue.value;
	
		answerTextFieldID = "textfieldR";
	}
	
    // Values you provide
    var textFieldToChange = document.getElementById(answerTextFieldID);	// replace with ID of text field
	
	if (isNumber(calcValue) && calcValue.length > 0) {
		if (calcValue != 0) {
			var unitNum = ConvertUnits[popupLIndex][popupRIndex];
			
			if (unitNum == 0) {
				// 0だったときは割り算にする
				unitNum = ConvertUnits[popupRIndex][popupLIndex];
				textFieldToChange.value = roundNum((calcValue / unitNum), 6);
//				textFieldToChange.value = calcValue / unitNum;
				
			} else {
				textFieldToChange.value = roundNum((calcValue * unitNum), 6);
//				textFieldToChange.value = calcValue * unitNum;
			}
		} else {
			textFieldToChange.value = 0;
		}
		
	} else {
		textFieldToChange.value = "";
	}
}


function ControlKeyCheck(charCode)
{
	if ((charCode >= 0 && charCode <= 32) || charCode == 127){
		return true;
	}
	return false;
}


function numUp(textFieldID)
{
    // Values you provide
    var textFieldValue = document.getElementById(textFieldID);	// replace with ID of text field
	textFieldValue.focus()
	if (isNumber(textFieldValue.value)) {
		textFieldValue.value = parseInt(textFieldValue.value) + 1;
	}
}

function numDown(textFieldID)
{
    // Values you provide
    var textFieldValue = document.getElementById(textFieldID);	// replace with ID of text field
	textFieldValue.focus()
	if (isNumber(textFieldValue.value)) {
		textFieldValue.value = parseInt(textFieldValue.value) - 1;
	}
}


function isNumber(numStr)
{
	return ((!isNaN(numStr)) && (numStr.length != 0));
}


function CalcJiokuri()
{
    var sizeFieldValue = document.getElementById("sizetext");	// replace with ID of text field
    var jikanFieldValue = document.getElementById("jikantext");	// replace with ID of text field
	
	var textFieldValue = document.getElementById("jiokuri");	// replace with ID of text field

	if (isNumber(sizeFieldValue.value) && isNumber(jikanFieldValue.value)) {
		var jiokuri = parseFloat(sizeFieldValue.value) + parseFloat(jikanFieldValue.value);
		
		textFieldValue.innerText = jiokuri.toString() + " H";
		
	} else {
		textFieldValue.innerText = "--" + " H";
	}
}


function CalcGyookuri()
{
    var sizeFieldValue = document.getElementById("sizetext");	// replace with ID of text field
    var gyokanFieldValue = document.getElementById("gyoukantext");	// replace with ID of text field

    var textFieldValue = document.getElementById("gyookuri");	// replace with ID of text field

	if (isNumber(sizeFieldValue.value) && isNumber(gyokanFieldValue.value)) {
		var gyookuri = parseFloat(sizeFieldValue.value) + parseFloat(gyokanFieldValue.value);
		
		textFieldValue.innerText = gyookuri.toString() + " H";
		
	} else {
		textFieldValue.innerText = "--" + " H";
	}
}


function CalcPageJiokuri()
{
    var sizeFieldValue = document.getElementById("sizetext");	// replace with ID of text field
    var jikanFieldValue = document.getElementById("jikantext");	// replace with ID of text field
    var mojisuFieldValue = document.getElementById("mojisutext");	// replace with ID of text field

	var textFieldValue = document.getElementById("jiokurisize");	// replace with ID of text field

	if (isNumber(sizeFieldValue.value) && isNumber(jikanFieldValue.value) && isNumber(mojisuFieldValue.value)) {
		var jiokuri = ((parseFloat(sizeFieldValue.value) + parseFloat(jikanFieldValue.value)) * (mojisuFieldValue.value - 1) + parseFloat(sizeFieldValue.value)) * 0.25;
//		jiokuri = (jiokuri * parseInt(mojisuFieldValue.value - 1) * 0.25) + parseFloat(sizeFieldValue.value);
//		jiokuri = jiokuri * parseInt(mojisuFieldValue.value) * 0.25;
		textFieldValue.value = roundNum(jiokuri, 6);
		
	} else {
		textFieldValue.value = 0;
	}
}


function CalcPageGyouokuri()
{
    var sizeFieldValue = document.getElementById("sizetext");	// replace with ID of text field
    var gyoukanFieldValue = document.getElementById("gyoukantext");	// replace with ID of text field
    var gyousuFieldValue = document.getElementById("gyousutext");	// replace with ID of text field
	
	var textFieldValue = document.getElementById("gyookurisize");	// replace with ID of text field

	if (isNumber(sizeFieldValue.value) && isNumber(gyoukanFieldValue.value) && isNumber(gyousuFieldValue.value)) {
		sizeFieldValue = parseFloat(sizeFieldValue.value);
		gyoukanFieldValue = parseFloat(gyoukanFieldValue.value);
		gyousuFieldValue = parseInt(gyousuFieldValue.value);

		var gyouokuri = sizeFieldValue + gyoukanFieldValue;
		gyouokuri = (gyouokuri * (gyousuFieldValue - 1) + sizeFieldValue) * 0.25;
		textFieldValue.value = roundNum(gyouokuri, 6);
		
	} else {
		textFieldValue.value = 0;
	}
}


function onclickSizeUp(event)
{
	numUp("sizetext");
	
	CalcJiokuri();
	CalcGyookuri();
	CalcPageJiokuri();
	CalcPageGyouokuri();
}


function onclickSizeDown(event)
{
    var textFieldValue = document.getElementById("sizetext");	// replace with ID of text field
	
	if (textFieldValue.value > 1) {
		numDown("sizetext");
	}
	
	CalcJiokuri();
	CalcGyookuri();

	CalcPageJiokuri();
	CalcPageGyouokuri();
}


function onclickJikanUp(event)
{
	numUp("jikantext");

	CalcJiokuri();
	CalcPageJiokuri();
}


function onclickJikanDown(event)
{
	numDown("jikantext");

	CalcJiokuri();
	CalcPageJiokuri();
}


function onclickGyokanUp(event)
{
	numUp("gyoukantext");

	CalcGyookuri();
	CalcPageGyouokuri();
}


function onclickGyokanDown(event)
{
	numDown("gyoukantext");

	CalcGyookuri();
	CalcPageGyouokuri();
}


function onclickMojisuUp(event)
{
	numUp("mojisutext");

	CalcPageJiokuri();
}


function onclickMojisuDown(event)
{
    var textFieldValue = document.getElementById("mojisutext");	// replace with ID of text field
	
	if (isNumber(textFieldValue.value) && textFieldValue.value > 0) {
		numDown("mojisutext");
	}

	CalcPageJiokuri();
}


function onclickGyosuUp(event)
{
	numUp("gyousutext");

	CalcPageGyouokuri();
}


function onclickGyosuDown(event)
{
    var textFieldValue = document.getElementById("gyousutext");	// replace with ID of text field
	
	if (isNumber(textFieldValue.value) && textFieldValue.value > 0) {
		numDown("gyousutext");
	}

	CalcPageGyouokuri();
}


function onkeyupSize(event)
{
	CalcJiokuri();
	CalcGyookuri();

	CalcPageJiokuri();
	CalcPageGyouokuri();
}


function onkeyupJikan(event)
{
	CalcJiokuri();
	CalcPageJiokuri();
}


function onkeyupGyoukan(event)
{
	CalcGyookuri();
	CalcPageGyouokuri();
}


function onkeyupMojisu(event)
{
	CalcPageJiokuri();
}


function onkeyupGyousu(event)
{
	CalcPageGyouokuri();
}


function onkeydownNumCheck(event)
{
	if (event.charCode == 45) {
		event.returnValue = false;
	}
}


function onclickWebSite(event)
{
	// Values you provide
	var websiteURL = "http://chinoken.net/";	// replace with the website URL to show

	// Show website code
	widget.openURL(websiteURL);
}

